# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_join.ipynb.

# %% auto 0
__all__ = ['charjoin', 'splitjoin', 'stripjoin', 'dotstr', 'dashstr', 's_str', 'd_str', 'nilstr', 'ustr', 'dustr', 'u1str',
           'u2str', 'sunstr', 'dunstr']

# %% ../nbs/10_join.ipynb 4
from typing import Any, Union, TypeAlias
from atyp import StrQ, StrGuard
from nchr import DOT, DASH, U1, U2, NIL
from chck import istuple
from atup import argtup


from .filt import dropnils
from .util import caststrs

# %% ../nbs/10_join.ipynb 6
def charjoin(char: str, *strs: str, nils: bool = False) -> str:
    strs = caststrs(*strs)
    strs = dropnils(*strs, drop = not nils)
    return char.join(strs)

def splitjoin(s: str, sep: str = DOT, char: str = U1, nils: bool = False) -> str:
    return charjoin(char, *s.split(sep), nils = nils)
    
def stripjoin(*strs: str, sep: str = DOT, nils: bool = False) -> str:
    strs = caststrs(*strs)
    strs = [s.strip(sep) for s in strs]
    strs = dropnils(*strs, drop = nils)
    return sep.join(strs)

# %% ../nbs/10_join.ipynb 7
def dotstr(*strs: str, nils: bool = False) -> str:  return charjoin(DOT, *strs, nils=nils)

def dashstr(*strs: str, nils: bool = False) -> str: return charjoin(DASH, *strs, nils=nils)

def s_str(*strs: str,  nils: bool = False) -> str:  return charjoin(U1, *strs, nils=nils)
def d_str(*strs: str,  nils: bool = False) -> str:  return charjoin(U2, *strs, nils=nils)
def nilstr(*strs: str, nils: bool = False) -> str:  return charjoin(NIL, *strs, nils=nils)

def ustr(*strs: str,   nils: bool = False) -> str:  return s_str(*strs, nils=nils)
def dustr(*strs: str,  nils: bool = False) -> str:  return d_str(*strs, nils=nils)

def u1str(*strs: str,  nils: bool = False) -> str:  return s_str(*strs, nils=nils)
def u2str(*strs: str,  nils: bool = False) -> str:  return d_str(*strs, nils=nils)

def sunstr(*strs: str, nils: bool = False) -> str:  return s_str(*strs, nils=nils)
def dunstr(*strs: str, nils: bool = False) -> str:  return d_str(*strs, nils=nils)
